<?php

namespace patest\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Security.PeripheralDevice StructType
 * @subpackage Structs
 */
class Security_PeripheralDevice extends AnyEntity
{
    /**
     * The ConfigEntityName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ConfigEntityName;
    /**
     * The DeviceCategory
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeviceCategory;
    /**
     * The DeviceName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeviceName;
    /**
     * The InfoForClients
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InfoForClients;
    /**
     * The SupportsConfigHints
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $SupportsConfigHints;
    /**
     * The Title
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Title;
    /**
     * Constructor method for Security.PeripheralDevice
     * @uses Security_PeripheralDevice::setConfigEntityName()
     * @uses Security_PeripheralDevice::setDeviceCategory()
     * @uses Security_PeripheralDevice::setDeviceName()
     * @uses Security_PeripheralDevice::setInfoForClients()
     * @uses Security_PeripheralDevice::setSupportsConfigHints()
     * @uses Security_PeripheralDevice::setTitle()
     * @param string $configEntityName
     * @param string $deviceCategory
     * @param string $deviceName
     * @param string $infoForClients
     * @param bool $supportsConfigHints
     * @param string $title
     */
    public function __construct($configEntityName = null, $deviceCategory = null, $deviceName = null, $infoForClients = null, $supportsConfigHints = null, $title = null)
    {
        $this
            ->setConfigEntityName($configEntityName)
            ->setDeviceCategory($deviceCategory)
            ->setDeviceName($deviceName)
            ->setInfoForClients($infoForClients)
            ->setSupportsConfigHints($supportsConfigHints)
            ->setTitle($title);
    }
    /**
     * Get ConfigEntityName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getConfigEntityName()
    {
        return isset($this->ConfigEntityName) ? $this->ConfigEntityName : null;
    }
    /**
     * Set ConfigEntityName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $configEntityName
     * @return \patest\StructType\Security_PeripheralDevice
     */
    public function setConfigEntityName($configEntityName = null)
    {
        // validation for constraint: string
        if (!is_null($configEntityName) && !is_string($configEntityName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($configEntityName, true), gettype($configEntityName)), __LINE__);
        }
        if (is_null($configEntityName) || (is_array($configEntityName) && empty($configEntityName))) {
            unset($this->ConfigEntityName);
        } else {
            $this->ConfigEntityName = $configEntityName;
        }
        return $this;
    }
    /**
     * Get DeviceCategory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeviceCategory()
    {
        return isset($this->DeviceCategory) ? $this->DeviceCategory : null;
    }
    /**
     * Set DeviceCategory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deviceCategory
     * @return \patest\StructType\Security_PeripheralDevice
     */
    public function setDeviceCategory($deviceCategory = null)
    {
        // validation for constraint: string
        if (!is_null($deviceCategory) && !is_string($deviceCategory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deviceCategory, true), gettype($deviceCategory)), __LINE__);
        }
        if (is_null($deviceCategory) || (is_array($deviceCategory) && empty($deviceCategory))) {
            unset($this->DeviceCategory);
        } else {
            $this->DeviceCategory = $deviceCategory;
        }
        return $this;
    }
    /**
     * Get DeviceName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeviceName()
    {
        return isset($this->DeviceName) ? $this->DeviceName : null;
    }
    /**
     * Set DeviceName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deviceName
     * @return \patest\StructType\Security_PeripheralDevice
     */
    public function setDeviceName($deviceName = null)
    {
        // validation for constraint: string
        if (!is_null($deviceName) && !is_string($deviceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deviceName, true), gettype($deviceName)), __LINE__);
        }
        if (is_null($deviceName) || (is_array($deviceName) && empty($deviceName))) {
            unset($this->DeviceName);
        } else {
            $this->DeviceName = $deviceName;
        }
        return $this;
    }
    /**
     * Get InfoForClients value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInfoForClients()
    {
        return isset($this->InfoForClients) ? $this->InfoForClients : null;
    }
    /**
     * Set InfoForClients value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $infoForClients
     * @return \patest\StructType\Security_PeripheralDevice
     */
    public function setInfoForClients($infoForClients = null)
    {
        // validation for constraint: string
        if (!is_null($infoForClients) && !is_string($infoForClients)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($infoForClients, true), gettype($infoForClients)), __LINE__);
        }
        if (is_null($infoForClients) || (is_array($infoForClients) && empty($infoForClients))) {
            unset($this->InfoForClients);
        } else {
            $this->InfoForClients = $infoForClients;
        }
        return $this;
    }
    /**
     * Get SupportsConfigHints value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getSupportsConfigHints()
    {
        return isset($this->SupportsConfigHints) ? $this->SupportsConfigHints : null;
    }
    /**
     * Set SupportsConfigHints value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $supportsConfigHints
     * @return \patest\StructType\Security_PeripheralDevice
     */
    public function setSupportsConfigHints($supportsConfigHints = null)
    {
        // validation for constraint: boolean
        if (!is_null($supportsConfigHints) && !is_bool($supportsConfigHints)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($supportsConfigHints, true), gettype($supportsConfigHints)), __LINE__);
        }
        if (is_null($supportsConfigHints) || (is_array($supportsConfigHints) && empty($supportsConfigHints))) {
            unset($this->SupportsConfigHints);
        } else {
            $this->SupportsConfigHints = $supportsConfigHints;
        }
        return $this;
    }
    /**
     * Get Title value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTitle()
    {
        return isset($this->Title) ? $this->Title : null;
    }
    /**
     * Set Title value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $title
     * @return \patest\StructType\Security_PeripheralDevice
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        if (is_null($title) || (is_array($title) && empty($title))) {
            unset($this->Title);
        } else {
            $this->Title = $title;
        }
        return $this;
    }
}
